<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `src&#x2F;helpers.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>helpers.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../day_2/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1"> 1</span>
<span id="2"> 2</span>
<span id="3"> 3</span>
<span id="4"> 4</span>
<span id="5"> 5</span>
<span id="6"> 6</span>
<span id="7"> 7</span>
<span id="8"> 8</span>
<span id="9"> 9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">std::cmp</span>;

<span class="doccomment">/// Gets the valus for a single row in the file</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">get_row_value</span>(<span class="ident">row</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="ident">row_iter</span> <span class="op">=</span> <span class="ident">row</span>.<span class="ident">split</span>(<span class="string">&quot;x&quot;</span>);
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">row_values</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span> <span class="op">=</span> <span class="macro">vec!</span>[];

    <span class="kw">for</span> <span class="ident">v</span> <span class="kw">in</span> <span class="ident">row_iter</span> {
        <span class="kw">if</span> <span class="ident">v</span>.<span class="ident">len</span>() <span class="op">=</span><span class="op">=</span> <span class="number">0</span> { <span class="kw">return</span> <span class="macro">vec!</span>[]; };
        <span class="ident">row_values</span>.<span class="ident">push</span>(<span class="ident">v</span>.<span class="ident">parse</span>().<span class="ident">unwrap</span>());
    }

    <span class="kw">return</span> <span class="ident">row_values</span>;
}

<span class="doccomment">/// Gets the minimum of x int values</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">get_min</span>(<span class="ident">args</span>: <span class="kw-2">&amp;</span>[<span class="ident">u32</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">u32</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">min</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="ident">std::u32::MAX</span>;
    <span class="kw">for</span> <span class="ident">a</span> <span class="kw">in</span> <span class="ident">args</span> {
        <span class="ident">min</span> <span class="op">=</span> <span class="ident">cmp::min</span>(<span class="ident">min</span>, <span class="kw-2">*</span><span class="ident">a</span>);
    }

    <span class="kw">return</span> <span class="ident">min</span>;
}

<span class="doccomment">/// Calculates a right ractangular prism area +</span>
<span class="doccomment">/// the smallest side area</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">calculate_wrapping_area</span>(<span class="ident">l</span>: <span class="ident">u32</span>, <span class="ident">w</span>: <span class="ident">u32</span>, <span class="ident">h</span>: <span class="ident">u32</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">u32</span> {
    <span class="kw">let</span> <span class="ident">sides1</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="number">2</span> <span class="op">*</span> <span class="ident">l</span> <span class="op">*</span> <span class="ident">w</span>;
    <span class="kw">let</span> <span class="ident">sides2</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="number">2</span> <span class="op">*</span> <span class="ident">w</span> <span class="op">*</span> <span class="ident">h</span>;
    <span class="kw">let</span> <span class="ident">sides3</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="number">2</span> <span class="op">*</span> <span class="ident">h</span> <span class="op">*</span> <span class="ident">l</span>;

    <span class="kw">let</span> <span class="ident">area</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="ident">sides1</span> <span class="op">+</span> <span class="ident">sides2</span> <span class="op">+</span> <span class="ident">sides3</span>;

    <span class="kw">let</span> <span class="ident">min_value</span> <span class="op">=</span> <span class="ident">get_min</span>(<span class="kw-2">&amp;</span>[<span class="ident">sides1</span> <span class="op">/</span> <span class="number">2</span>, <span class="ident">sides2</span> <span class="op">/</span> <span class="number">2</span>, <span class="ident">sides3</span> <span class="op">/</span> <span class="number">2</span>]);

    <span class="kw">let</span> <span class="ident">to_return</span> <span class="op">=</span> <span class="ident">area</span> <span class="op">+</span> <span class="ident">min_value</span>;

    <span class="kw">return</span> <span class="ident">to_return</span>;
}

<span class="doccomment">/// Calculates the legth of ribbon needed for present and bow</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">calculate_ribbon_length</span>(<span class="ident">dimensions</span> :<span class="kw-2">&amp;</span><span class="ident">str</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">u32</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">box_dimensions</span> <span class="op">=</span> <span class="ident">get_row_value</span>(<span class="ident">dimensions</span>);

    <span class="comment">// a * b * c</span>
    <span class="kw">let</span> <span class="ident">bow_length</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="ident">box_dimensions</span>[<span class="number">0</span>]
    <span class="op">*</span> <span class="ident">box_dimensions</span>[<span class="number">1</span>]
    <span class="op">*</span> <span class="ident">box_dimensions</span>[<span class="number">2</span>];

    <span class="comment">// 2 * smallest + 2 * second smallest</span>
    <span class="ident">box_dimensions</span>.<span class="ident">sort</span>();

    <span class="kw">let</span> <span class="ident">ribbon_length</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="ident">box_dimensions</span>[<span class="number">0</span>]
        <span class="op">+</span> <span class="ident">box_dimensions</span>[<span class="number">0</span>]
        <span class="op">+</span> <span class="ident">box_dimensions</span>[<span class="number">1</span>]
        <span class="op">+</span> <span class="ident">box_dimensions</span>[<span class="number">1</span>];

    <span class="kw">return</span> <span class="ident">ribbon_length</span> <span class="op">+</span> <span class="ident">bow_length</span>;
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="day_2" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>